package jadex.adapter.jade.planlib;

import jade.core.Agent;
import jade.wrapper.AgentContainer;
import jade.wrapper.AgentController;
import jade.wrapper.ControllerException;
import jadex.adapter.fipa.AgentIdentifier;
import jadex.runtime.Plan;

/**
 *  Plan for starting a Jadex agent on JADE.
 */
public class JadeAMSStartAgentPlan extends Plan
{
	//-------- constants --------

	/** The agent counter. */
	public static int agentcnt = 0;

	//-------- methods --------

	/**
	 *  Execute a plan.
	 */
	public void body()
	{
		// todo: support starting in another container?!
		AgentIdentifier	aid	= (AgentIdentifier)getParameter("agentidentifier").getValue();
		AgentIdentifier	amsfipa	= (AgentIdentifier)getParameter("ams").getValue();

		// If ams is specified use remote code.
		if(amsfipa!=null)
		{
			throw new RuntimeException("JADE adapter can only start agents created with start==false.");
		}
		
		// Otherwise start agent locally.
		else
		{
			try
			{
				AgentContainer container = ((Agent)getScope().getPlatformAgent()).getContainerController();
				AgentController	controller = container.getAgent(aid.getLocalName());
				controller.start();
			}
			catch(ControllerException e)
			{
				throw new RuntimeException("Error starting agent "+aid+"\n", e);
			}
		}
	}
}
