package	jadex.adapter.jade.planlib;

import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.*;
import jadex.adapter.jade.SJade;
import jadex.runtime.IGoal;

import java.util.Date;

/**
 *  The df registering behavior registers a df agent description at a df.
 */
public class JadeDFRegisterPlan	extends	JadeDFPlan
{
	//-------- attributes --------

	/** The register goal. */
	// Hack!!! Needed for failed()
	protected IGoal	req;

	//-------- constructors --------

	/**
	 *  Create a plan for registering with a df.
	 */
	public JadeDFRegisterPlan()
	{
		// Set the lease time. Will maybe get one from server if not set.
		Long lt = (Long)getParameter("leasetime").getValue();
		if(lt!=null)
		{
			//getAgentDescription().setRelativeLeaseTime(lt.longValue());
			getAgentDescription().setLeaseTime(
				new Date(System.currentTimeMillis()+lt.longValue()));
		}
		// When AID is ommited, enter self. Hack???
		if(getAgentDescription().getName()==null)
			getAgentDescription().setName(((Agent)getCapability().getPlatformAgent()).getAID());
	}

	//-------- methods --------

	/**
	 *  MobilePlan body.
	 */
	public void	body()
	{
		// Create and dispatch register goal.
		Register	register	= new Register();
		register.setDescription(getAgentDescription());
		Action action = new Action();
		action.setActor(SJade.convertAIDtoJade(getDF()));
		action.setAction(register);

		req	= createGoal("rp_initiate");
		req.getParameter("receiver").setValue(getDF());
		req.getParameter("action").setValue(action);
		req.getParameter("ontology").setValue(FIPAManagementOntology.NAME);
		req.getParameter("language").setValue(jade.domain.FIPANames.ContentLanguage.FIPA_SL0);
		dispatchSubgoalAndWait(req);

		//System.out.println("Registered: "+ge.getGoal().getResult());
		Register reg	= (Register)((Action)((jade.content.onto.basic.Done)req
			.getParameter("result").getValue()).getAction()).getAction();

		Object desc = reg.getDescription();
		desc = SJade.convertAgentDescriptiontoFipa((DFAgentDescription)desc);
		getParameter("result").setValue(desc);
	}

	public void failed()
	{
		// Mega hack!!! to handle Jade bug of false encoded df replies.
		if(req!=null)
		{
			Long lt = (Long)getParameter("leasetime").getValue();
			Object res = req.getParameter("result").getValue();
			if(res instanceof String
				&& ((String)res).indexOf("already-registered")!=-1
				&& getRootGoal().getType().equals("df_keep_registered")
				&& lt!=null)
			{
				DFAgentDescription	ades	= getAgentDescription();
				ades.setLeaseTime(new Date(System.currentTimeMillis()-lt.longValue()));
				Register	register	= new Register();
				register.setDescription(ades);
				getParameter("result").setValue(ades);
			}
		}
	}
}

