package	jadex.adapter.jade.planlib.mobile;

import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.Register;
import jadex.adapter.jade.SJade;
import jadex.runtime.IEvent;
import jadex.runtime.IGoal;
import jadex.runtime.IGoalEvent;

import java.util.Date;

/**
 *  The df registering behavior registers a df agent description at a df.
 */
public class JadeDFRegisterPlan	extends	JadeDFPlan
{
	//-------- attributes --------

	/** The register goal. */
	// Hack!!! Needed for failed()
	protected IGoal	reggoal;

	//-------- constructors --------

	/**
	 *  Create a plan for registering with a df.
	 */
	public JadeDFRegisterPlan()
	{
		// Set the lease time. Will maybe get one from server if not set.
		Long lt = (Long)getParameter("leasetime").getValue();
		if(lt!=null && lt.longValue()!=0)
		{
			//getAgentDescription().setRelativeLeaseTime(lt.longValue());
			getAgentDescription().setLeaseTime(
				new Date(System.currentTimeMillis()+lt.longValue()));
		}
		// When AID is ommited, enter self. Hack???
		if(getAgentDescription().getName()==null)
			getAgentDescription().setName(((Agent)getCapability().getPlatformAgent()).getAID());
	}

	//-------- methods --------

	/**
	 *  MobilePlan body.
	 */
	public void	action(IEvent event)
	{
		if(event instanceof IGoalEvent && !((IGoalEvent)event).isInfo())
		{
			// Create and dispatch register goal.
			Register	register	= new Register();
			register.setDescription(getAgentDescription());
			Action action = new Action();
			action.setActor(SJade.convertAIDtoJade(getDF()));
			action.setAction(register);
	
			reggoal	= dispatchDFRequestAndWait(action);
		}
		else
		{
			//System.out.println("result: "+reggoal.isSucceeded());
	
			//System.out.println("Registered: "+ge.getGoal().getResult());
			Register reg	= (Register)((Action)((jade.content.onto.basic.Done)reggoal
				.getParameter("result").getValue()).getAction()).getAction();
	
			Object desc= reg.getDescription();
			desc = SJade.convertAgentDescriptiontoFipa((DFAgentDescription)desc);
			getParameter("result").setValue(desc);
		}
	}

	public void failed(IEvent event)
	{
		// Mega hack!!! to handle Jade bug of false encoded df replies.
		Long lt = (Long)getParameter("leasetime").getValue();
		if(reggoal.getParameter("result").getValue() instanceof String
			&& ((String)reggoal.getParameter("result").getValue()).indexOf("already-registered")!=-1
			&& getRootGoal().getType().equals("df_keep_registered")
			&& lt!=null)
		{
			DFAgentDescription	ades	= getAgentDescription();
			ades.setLeaseTime(new Date(System.currentTimeMillis()-lt.longValue()));
			getParameter("result").setValue(SJade.convertAgentDescriptiontoFipa(ades));
		}
	}
}

