package jadex.adapter.jade.tools.common;

import jadex.util.*;

import javax.swing.border.Border;

import java.awt.Dimension;
import java.awt.event.ActionListener;
import javax.swing.*;

import java.awt.event.ActionEvent;

/**
 *  Button to start a web browser showing the Jadex Home page.
 */
public class JadexLogoButton extends JButton
{
	private static UIDefaults icons = new UIDefaults(new Object[]
	{
         "JadexLogo", SGUI.makeIcon(JadexLogoButton.class, "/jadex/adapter/jade/tools/common/images/jadexlogo.png"),
         "JadexLogoV", SGUI.makeIcon(JadexLogoButton.class, "/jadex/adapter/jade/tools/common/images/jadexlogoV.png"),
	});
   
    private final JToolBar tb;
    private int last_orient;

	/** 
	 * Constructor for JadexLogoButton.
	 * @param tb
	 */
	public JadexLogoButton(JToolBar tb)
	{
		super(icons.getIcon("JadexLogo"));
        this.tb = tb;
		setBorder(BorderFactory.createRaisedBevelBorder());
//      setMargin(new Insets(1,1,1,1));
		setToolTipText("Go to Jadex Home Page");
		addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				try
				{
					BrowserLauncher2.openURL("http://vsis-www.informatik.uni-hamburg.de/projects/jadex");
				}
				catch(java.io.IOException ex)
				{
					ex.printStackTrace();
				}
			}
		});
      last_orient=tb.getOrientation();
	}
   
   

   /** 
    * @return
    * @see java.awt.Component#getPreferredSize()
    */
   public Dimension getPreferredSize()
   {
      int orient=tb.getOrientation();
      if (orient!=last_orient) {
         switch(tb.getOrientation()) {
         case JToolBar.HORIZONTAL: 
            setIcon(icons.getIcon("JadexLogo"));
            break;
         case JToolBar.VERTICAL: 
            setIcon(icons.getIcon("JadexLogoV"));
         }
         last_orient=orient;
      }
      
      return super.getPreferredSize();
   }
}