/*****************************************************************
 JADE - Java Agent DEvelopment Framework is a framework to develop multi-agent systems in compliance with the FIPA specifications.
 Copyright (C) 2000 CSELT S.p.A.

 GNU Lesser General Public License

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation,
 version 2.1 of the License.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA  02111-1307, USA.
 *****************************************************************/

package jadex.adapter.jade.tools.logger.gui;


import javax.swing.*;
import java.awt.Insets;
import jadex.adapter.jade.tools.common.JadexLogoButton;


/**

 @author Francisco Regi, Andrea Soracchi - Universita` di Parma
 <Br>
 <a href="mailto:a_soracchi@libero.it"> Andrea Soracchi(e-mail) </a>
 @version $Date: 2005-11-29 08:53:43 +0000 (Tue, 29 Nov 2005) $ $Revision: 3691 $
 */

/**
 * Sets up the toolbar for the main Sniffer Gui
 *
 * @see javax.swing.JToolBar
 */

final public class ToolBar extends JToolBar
{

    private ActionProcessor actPro;
    private LoggerAction obj;
    protected JToggleButton showFilter;
    protected JToggleButton enableFilter;

    public ToolBar(ActionProcessor actPro)
    {
        setBorderPainted(true);
        this.actPro = actPro;
        addSeparator();
        addAction();
        add(Box.createHorizontalGlue());
        JadexLogoButton logo = new JadexLogoButton(this);
        add(logo);
    }

    private AbstractButton setButton(AbstractButton b)
    {
        b.setToolTipText(obj.getActionName());
        b.setText("");
        b.setRequestFocusEnabled(false);
        b.setMargin(new Insets(1, 1, 1, 1));
        return b;
    }

    private void addAction()
    {

        obj = (LoggerAction) actPro.actions.get(actPro.CLEARTABLE_ACTION);
        setButton(add(obj));

        addSeparator();

        obj = (LoggerAction) actPro.actions.get(actPro.WRITELOGFILE_ACTION);
        setButton(add(obj));

        addSeparator();

        obj = (LoggerAction) actPro.actions.get(actPro.DO_LOGGER_ACTION);
        setButton(add(obj));
        obj = (LoggerAction) actPro.actions.get(actPro.DO_NOT_LOGGER_ACTION);
        setButton(add(obj));

        addSeparator();

        obj = (LoggerAction) actPro.actions.get(actPro.TOGGLEFILTER_ACTION);
        enableFilter =new JToggleButton(obj);
        add(setButton(enableFilter));
        obj = (LoggerAction) actPro.actions.get(actPro.EDITFILTER_ACTION);
        showFilter=new JToggleButton(obj);
        add(setButton(showFilter));
        obj = (LoggerAction) actPro.actions.get(actPro.REMOVEFILTER_ACTION);
        setButton(add(obj));

        addSeparator();

        obj = (LoggerAction) actPro.actions.get(actPro.TOGGLEDISPLAYING_ACTION);
        add(setButton(new JToggleButton(obj)));
        obj = (LoggerAction) actPro.actions.get(actPro.TOGGLEAUTOSCROLL_ACTION);
        add(setButton(new JToggleButton(obj)));
        obj = (LoggerAction) actPro.actions.get(actPro.RESIZEALLCOLUMNS_ACTION);
        setButton(add(obj));

        addSeparator();

//        obj = (LoggerAction) actPro.actions.get(actPro.PRELOAD_LIST_ACTION);
//        setButton(add(obj));
//
//        addSeparator();

        obj = (LoggerAction) actPro.actions.get(actPro.ADDREMOTEPLATFORM_ACTION);
        setButton(add(obj));


        addSeparator();

        obj = (LoggerAction) actPro.actions.get(actPro.EXIT_LOGGER_ACTION);
        setButton(add(obj));

		addSeparator();
    }

}
