/*****************************************************************
 JADE - Java Agent DEvelopment Framework is a framework to develop
 multi-agent systems in compliance with the FIPA specifications.
 Copyright (C) 2000 CSELT S.p.A.

 GNU Lesser General Public License

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation,
 version 2.1 of the License.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA  02111-1307, USA.
 *****************************************************************/

package jadex.adapter.jade.tools.logger.gui;


import jade.tools.sniffer.MessageList;
import jade.tools.sniffer.Message;
import jade.util.leap.ArrayList;

import javax.swing.*;
import java.io.*;
import java.util.Iterator;


/**
 Javadoc documentation for the file
 @author Francisco Regi, Andrea Soracchi - Universita` di Parma
 <Br>
 <a href="mailto:a_soracchi@libero.it"> Andrea Soracchi(e-mail) </a>
 @version $Date: 2006-12-17 18:48:14 +0000 (Sun, 17 Dec 2006) $ $Revision: 4676 $
 */

/**
 * Creates a serialized snapshot of the agents and sniffed messages in both canvases for
 * later recall.
 *
 */

public class WriteLogFileAction extends FixedAction implements Serializable
{

    private MainPanel mainPanel;

    public WriteLogFileAction(ActionProcessor actPro, MainPanel mainPanel)
    {
        super("WriteLogFileActionIcon", "Save Log Entries to File", actPro);
        this.mainPanel = mainPanel;
    }

    public void doAction()
    {
        try
        {
            JFileChooser fileDialog = new JFileChooser(".");
            int returnVal = fileDialog.showSaveDialog(null);
            if (returnVal == JFileChooser.APPROVE_OPTION)
            {
                String fileName = fileDialog.getSelectedFile().getAbsolutePath();
                FileOutputStream istream = new FileOutputStream(fileName);
                PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(fileName)));

                Iterator it = mainPanel.logTable.getLogList().iterator();
                while (it.hasNext())
                {
                    String line = (String) it.next();
                    out.println(line);
                }
                out.close();

            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

}