package jadex.adapter.jade.tools.logger.jadeexample;

import java.util.logging.*;
import jade.core.behaviours.TickerBehaviour;

/**
 *  Behaviour which increments periodically a belief.
 */
class BeliefIncrementBehaviour extends TickerBehaviour
{
 	//-------- attributes --------

    private LogAgent logagent;
    private Logger logger;

 	//-------- constructors --------

	/**
	 *  Create a new increment plan.
	 * 	@param logagent The log agent.
	 */
    public BeliefIncrementBehaviour(LogAgent logagent)
    {
        super(logagent, LogAgent.INCREMENT_TIME);
        this.logagent = logagent;
        this.logger = logagent.getLogger();
    }

 	//-------- methods --------

	/**
	 *  Increment the belief.
	 */
    protected void onTick()
    {
        // Increment belief
        logagent.data++;

        // Create a log message with level fine
        logger.log(Level.FINE, "Belief incremented to: " + logagent.data);
    }
}
