/*****************************************************************
 JADE - Java Agent DEvelopment Framework is a framework to develop
 multi-agent systems in compliance with the FIPA specifications.
 Copyright (C) 2000 CSELT S.p.A.

 GNU Lesser General Public License

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation,
 version 2.1 of the License.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA  02111-1307, USA.
 *****************************************************************/


package jadex.adapter.jade.tools.rma;

import java.io.IOException;

import jade.gui.AgentTree;
import jadex.model.SXML;

import javax.swing.*;

//import jadex.tools.common.GuiProperties;


/**

 @author Francisco Regi, Andrea Soracchi - Universita` di Parma
 @version $Date: 2005-11-29 17:08:30 +0000 (Tue, 29 Nov 2005) $ $Revision: 3702 $
 */
//class LoggerAction extends FixedAction {

class JadexIntrospectorAction extends ContainerAction {
    private static int progressiveNumber = 0;
    private rma myRMA;

    public JadexIntrospectorAction(rma anRMA, ActionProcessor actPro) {
        // GuiProperties in jadex.tools.gui !!!!
        super("JadexIntrospectorActionIcon", "Start Jadex Control Center", actPro);
        myRMA = anRMA;
    }

    public void doAction(AgentTree.ContainerNode node) {
    	try {
    		SXML.loadAgentModel("jadex/tools/jcc/JCC.agent.xml", null);
    	} catch(IOException e) {
       		JOptionPane.showMessageDialog(new JFrame(),"Jadex JCC not installed (check classpath).","Start Tool Error",JOptionPane.ERROR_MESSAGE);
    		return;
    	}
        String containerName = new String();
        if (node != null)
            containerName = node.getName();

		myRMA.newAgent("jadex_jcc" + progressiveNumber, jadex.adapter.jade.JadeAgentAdapter.class.getName()
			, new String[]{"jadex/tools/jcc/JCC.agent.xml", ""}, containerName);
        progressiveNumber++;
    }

}

